/*
 * GraphBase.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef GRAPHBASE_H_
#define GRAPHBASE_H_

#include <list>

using namespace std;

namespace Graph {


class Graph;

class GraphBase {

protected:

	/**
	 * seznam zakladnich objektu
	 */
	typedef list<GraphBase*> BaseList;

	/**
	 * prida ukazatel na sebe do ciziho seznamu
	 */
	void addToToOtherList(GraphBase* other, int index);

	/**
	 * odebere sebe z ciziho seznamu
	 */
	void removeFromOtherList(GraphBase* other, int index);

	/**
	 * odebere sebe ze vsech cizich seznamu
	 */
	void removeFromOtherLists(GraphBase* other);

	/**
	 * vytvori novy seznam a vraci jeho index
	 */
	int createList();

	/**
	 * vytvori dany pocet novych seznamu a vraci celkovy pocet seznamu v poli
	 */
	int createLists(int cnt);

	/**
	 * smaze seznam dle indexu
	 */
	void deleteList(int index);

	/**
	 * vraci celkovy pocet seznamu
	 */
	int getCount();

	/**
	 * vraci ukazatel na seznam dle indexu
	 */
	BaseList* getList(int index) const;

private:

	/**
	 * celkova velikost alokovaneho pole seznamu
	 */
	int allocatedCnt;

	/**
	 * skutecny pocet seznamu
	 */
	int listCnt;

	/**
	 * pole se seznamy
	 */
	BaseList** lists;

	/**
	 * rodicovsky graf vlastnici prvek
	 */
	const Graph* parentGraph;

	/**
	 * metoda pro alokaci mista pro seznamy
	 */
	void allocate(int n);

public:

	/**
	 * vytvori prazdne pole seznamu
	 */
	GraphBase(const Graph* graph);

	/**
	 * vytvori v poli dany pocet prvku
	 */
	GraphBase(const Graph* graph, int cnt);

	/**
	 * destruktor
	 */
	virtual ~GraphBase();

	const Graph* graph();

	GraphBase& operator=(const GraphBase& o);
};

}

#include "Graph.h"


#endif /* GRAPHBASE_H_ */
