/*
 * Assembler.h
 *
 *  Created on: 3.3.2013
 *      Author: petr
 */

#ifndef ASSEMBLER_H_
#define ASSEMBLER_H_

#include "ParamLoadable.h"

namespace FiniteAutomat {

class Assembler: public FiniteAutomat::ParamLoadable {
public:
	Assembler();
	virtual ~Assembler();

	/**
	 * slozi data nactena z agroegovaneho automatu s puvodnimi daty
	 *
	 * @param void* original data z puvodniho automatu
	 * @param void* agregated data nactena z agregovaneho automatu
	 * @return void*
	 */
	virtual void* assemble(void* original, void* agregated) = 0;

	/**
	 * naklonuje instanci
	 */
	virtual Assembler* clone() = 0;

	/**
	 * pripravi data pro agregovany automat a vraci ukazatel na ne
	 *
	 * @return void*
	 */
	virtual void* prepare() = 0;

	/**
	 * provede revert operace assemble
	 *
	 * @param void* original data nactena nadrazenym automatem
	 * @param void* agregated data nactena agregovanym automatem
	 */
	virtual void* revert(void* original, void* agregated) = 0;
};

} /* namespace FiniteAutomat */
#endif /* ASSEMBLER_H_ */
