/*
 * AssemblerStringBubbler.h
 *
 *  Created on: 3.3.2013
 *      Author: petr
 */

#ifndef ASSEMBLERSTRINGBUBBLER_H_
#define ASSEMBLERSTRINGBUBBLER_H_

#include "Assembler.h"
#include <string>

namespace FiniteAutomat {

class AssemblerStringBubbler: public FiniteAutomat::Assembler {
public:
	AssemblerStringBubbler();
	AssemblerStringBubbler(const AssemblerStringBubbler& o);
	virtual ~AssemblerStringBubbler();


	/**
	 * presune nactena data z vnoreneho automatu do automatu vys
	 *
	 * @param void* original data z puvodniho automatu
	 * @param void* agregated data nactena z agregovaneho automatu
	 * @return void*
	 */
	virtual void* assemble(void* original, void* agregated);

	/**
	 * naklonuje instanci
	 */
	virtual Assembler* clone();

	/**
	 * vraci ukazatel na retezec
	 *
	 * @return void*
	 */
	virtual void* prepare();

	/**
	 * smaze retezec z puvodnich dat
	 */
	virtual void* revert(void* original, void* agregated);
};

} /* namespace FiniteAutomat */
#endif /* ASSEMBLERSTRINGBUBBLER_H_ */
