/*
 * FilterCase.h
 *
 *  Created on: 28.2.2013
 *      Author: petr
 */

#ifndef FILTERCASE_H_
#define FILTERCASE_H_

#include "Filter.h"

namespace FiniteAutomat {

class FilterCase: public FiniteAutomat::Filter {
public:

	static const char* PARAM_TOLOWER;

	static const unsigned char LOWER_LOW_BOUNDARY;
	static const unsigned char LOWER_UP_BOUNDARY;
	static const unsigned char UPPER_LOW_BOUNDARY;
	static const unsigned char UPPER_UP_BOUNDARY;
	static const unsigned char OFFSET;

	/**
	 * pokud je FALSE, vysledny retezec bude upper case
	 * v ostatnich pripadech bude lower case
	 */
	bool toLower;

	FilterCase();
	virtual ~FilterCase();

	/**
	 * prvede vstupni retezec na velka nebo mala pismena
	 * velikost pismen zalezi na prepinaci toLower
	 */
	WRITE_DOFILTER_HEADER

	/**
	 * nastavi parametry
	 * podporovane parametry jsou
	 * - tolower - hodnota prepinace toLower
	 */
	WRITE_SETPARAM_HEADER
};

} /* namespace FiniteAutomat */
#endif /* FILTERCASE_H_ */
