/*
 * InputData.h
 *
 *  Created on: 26.2.2013
 *      Author: petr
 */

#ifndef INPUTDATA_H_
#define INPUTDATA_H_

#include <string>
#include "ExceptionOutOfBounds.h"

namespace FiniteAutomat {

class InputData {

	std::string *data;

	std::size_t length;

	std::size_t position;

	size_t* instanceCounter;

public:
	InputData();
	InputData(const std::string &data, std::size_t position);
	InputData(const InputData &o);
	virtual ~InputData();

	/*
	 * vraci datovy retezec
	 */
	std::string getData() const;

	/*
	 * vraci delku datoveho retezce
	 */
	std::size_t getLength() const;

	/*
	 * vraci pozici v datovem retezci
	 */
	std::size_t getPosition() const;

	/**
	 * vraci podretezec o delce n znaku
	 * v puvodnim retezci zacina podretezec na aktualni pozici
	 * pokud je move==TRUE, pak se posune ukazatel aktualni pozice
	 *
	 * @param std::size_t n pocet nacitanych znaku
	 * @param bool move prepinac posuniti ukazatele position
	 * @return std::string
	 */
	std::string getSubstr(std::size_t n, bool move);

	/*
	 * nastavi novou pozici v datovem retezci
	 */
	void setPosition(std::size_t p);

	/**
	 * operator prirazeni
	 */
	InputData& operator=(const InputData& o);
};

} /* namespace FiniteAutomat */
#endif /* INPUTDATA_H_ */
