/*
 * LoaderWord.h
 *
 *  Created on: 27.2.2013
 *      Author: petr
 */

#ifndef LOADERWORD_H_
#define LOADERWORD_H_

#include "Loader.h"

namespace FiniteAutomat {

class LoaderWord: public FiniteAutomat::Loader {

	/**
	 * retezec obsahujici skutecne pouzite ukoncovaci znaky slova
	 * krome bilych znaku se muze jednat napriklad o uvozovky, zavorky a podobne
	 */
	std::string terminals;

public:

	/**
	 * ascapovaci znak
	 */
	char escape;

	static const char* PARAM_ADD;
	static const char* PARAM_REPLACE;
	static const char* PARAM_ESCAPE;

	LoaderWord();
	LoaderWord(const LoaderWord& o);
	virtual ~LoaderWord();

	/**
	 * prida k retezci terminalu nove terminaly
	 *
	 * @param std:string terms retezec obsahujici nove terminaly
	 */
	void addTerms(std::string terms);

	/**
	 * nacte prave n znaku ze vstupnich dat
	 */
	WRITE_LOAD_HEADER

	/**
	 * nahradi stavajici retezec novym retezcem terminalu
	 *
	 * @param std::string novy retezec terminalu
	 */
	void replaceTerms(std::string terms);

	/**
	 * nastavi parametry
	 * povolene parametry jsou:
	 * - addterms -> prida k ukoncovacim znakum dalsi znaky
	 * - replaceterms -> nahradi ukoncovaci znaky novymi
	 */
	WRITE_SETPARAM_HEADER

	/**
	 * naklonuje instanci
	 *
	 * @return Loader*
	 */
	WRITE_LOADERCLONE_HEADER
};

} /* namespace FiniteAutomat */
#endif /* LOADERWORD_H_ */
