/*
 * Machine.h
 *
 *  Created on: 26.2.2013
 *      Author: petr
 */

#ifndef MACHINE_H_
#define MACHINE_H_

#include "config.h"
#include "Graph.h"
#include "StateInstance.h"
#include "State.h"
#include "InputData.h"

namespace FiniteAutomat {

#ifndef CLASS_STATE
class State;
#endif

#ifndef CLASS_STATEINSTANCE
class StateInstance;
#endif

#define CLASS_MACHINE

class Machine: public Graph::Graph {

	/*
	 * ukazatel na vychozi stav automatu
	 */
	State* initialState;

public:
	Machine();
	Machine(const Machine& o);
	virtual ~Machine();

	/*
	 * vraci stav, ktery je vystupnim stavem
	 *
	 * @return State*
	 */
	State* getInitialInstance();

	/*
	 * zpracuje automat a vraci ukazatel na privni instanci stavu v retezci
	 *
	 * @param InputData data vstupni data
	 * @return StateInstance*
	 */
	StateInstance* run(InputData data, void* processData);

	/*
	 * nastavi vstupni stav automatu
	 *
	 * @param State* state novy vstupni stav
	 */
	void setInitialState(State* state);
};

} /* namespace FiniteAutomat */
#endif /* MACHINE_H_ */
