/*
 * ParamLoadable.h
 *
 *  Created on: 27.2.2013
 *      Author: petr
 */

#ifndef PARAMLOADABLE_H_
#define PARAMLOADABLE_H_

#include <string>
#include <cstdio>

namespace FiniteAutomat {

#define WRITE_SETPARAM_HEADER virtual void setParameter(std::string name, std::string value);
#define WRITE_SETPARAM_IMPL(CLASS) void CLASS::setParameter(std::string name, std::string value)

class ParamLoadable {
public:

	static const char* BOOL_TRUE1;
	static const char* BOOL_TRUE2;
	static const char* BOOL_TRUE3;
	static const char* BOOL_TRUE4;
	static const char* BOOL_TRUE5;

	ParamLoadable();
	virtual ~ParamLoadable();

	/**
	 * nastavi parametr
	 * slouzi k naslednemu prepisovani potomky
	 *
	 * @param std::string name jmeno hodnoty
	 * @param std::string value hodnota
	 */
	WRITE_SETPARAM_HEADER

	/**
	 * prevede hodnotu v parametru na logickou hodnotu
	 * jako logicke jednicky jsou iterpretovany
	 * - 1
	 * - true
	 * - TRUE
	 * - t
	 * - T
	 *
	 * vse ostatni je interpretovano jako nula
	 *
	 * @param std::string value hodnota k prevedeni
	 * @return bool
	 */
	bool toBool(std::string value);
};

} /* namespace FiniteAutomat */
#endif /* PARAMLOADABLE_H_ */
