/*
 * Processor.h
 *
 *  Created on: 2.3.2013
 *      Author: petr
 */

#ifndef PROCESSOR_H_
#define PROCESSOR_H_

#include "config.h"
#include "ParamLoadable.h"

namespace FiniteAutomat {

#define PROCESSOR_DESTROY virtual void destroy(void* processData)
#define PROCESSOR_DESTROY_I(CLASS) void CLASS::destroy(void* processData)
#define PROCESSOR_PROCESS virtual void* process(void* processData, const TRANSIT_RESULT& readData)
#define PROCESSOR_PROCESS_I(CLASS) void* CLASS::process(void* processData, const TRANSIT_RESULT& readData)
#define PROCESSOR_CLONE virtual Processor* clone()
#define PROCESSOR_CLONE_I(CLASS) Processor* CLASS::clone()
#define PROCESSOR_REVERT virtual void* revert(void* processData, const TRANSIT_RESULT& readData)
#define PROCESSOR_REVERT_I(CLASS) void* CLASS::revert(void* processData, const TRANSIT_RESULT& readData)

class Processor : public ParamLoadable {
public:
	Processor();
	Processor(const Processor& o);
	virtual ~Processor();

	PROCESSOR_DESTROY = 0;

	PROCESSOR_PROCESS = 0;

	PROCESSOR_CLONE = 0;

	PROCESSOR_REVERT = 0;
};

} /* namespace FiniteAutomat */
#endif /* PROCESSOR_H_ */
