/*
 * StateAgregated.h
 *
 *  Created on: 3.3.2013
 *      Author: petr
 */

#ifndef STATEAGREGATED_H_
#define STATEAGREGATED_H_

#include "State.h"
#include "Assembler.h"
#include "Machine.h"
#include "StateAgregatedInstance.h"

namespace FiniteAutomat {

class StateAgregated: public FiniteAutomat::State {

	/**
	 * vnoreny automat
	 */
	Machine* agregatedMachine;

	/**
	 * sestavovatel dat
	 */
	Assembler* assembler;

public:
	StateAgregated(Machine* machine, Machine* agregatedMachine);
	virtual ~StateAgregated();

	/**
	 * vytvori instanci stavu
	 * vraci ukazatel na StateInstance, ktery ve skutecnosti ukazuje na StateAgregatedInstance
	 */
	virtual StateInstance* createInstance(InputData data, StateInstance* prev, void* processData, TRANSIT_RESULT readData);

	/**
	 * vraci sestavovatel dat
	 *
	 * @return Assembler*
	 */
	Assembler* getAssembler();

	/**
	 * vraci zanoreny automat
	 *
	 * @return Machine*
	 */
	Machine* getAgregatedMachine();

	/**
	 * nastavi sestavovatel
	 *
	 * @param Assembler* novy sestavovatel
	 */
	void setAssembler(Assembler* assembler);

	/**
	 * nastavi novy zanoreny automat (stary je znicen)
	 *
	 * @param Machine* ukazatel na novy automat
	 */
	void setAgregatedMachine(Machine* agregatedMachine);

	/**
	 * nedela nic, pouze prepisuje puvodni metodu
	 *
	 * @param Processor* procesor ukazatel, ktery bude zahozen
	 */
	virtual void setProcessor(Processor* processor);
};

} /* namespace FiniteAutomat */
#endif /* STATEAGREGATED_H_ */
