/*
 * TestLength.h
 *
 *  Created on: 28.2.2013
 *      Author: petr
 */

#ifndef TESTLENGTH_H_
#define TESTLENGTH_H_

#include "Test.h"

namespace FiniteAutomat {

class TestLength: public FiniteAutomat::Test {

	static const char SHORTER;		// testovany retezec musi byt kratsi
	static const char EQUAL;		// testovany retezec musi byt presne dlouhy
	static const char LONGER;		// testovany retezec musi byt delsi

public:

	static const char* PARAM_LENGTH;	// nastavuje delku k porovnani
	static const char* PARAM_TYPE;		// nastavuje typ porovnani
	static const char* COMP_SHORTER;	// zkoumany retezec musi byt kratsi
	static const char* COMP_EQUAL;		// zkoumany retezec musi byt stejne dlouhy
	static const char* COMP_LONGER;		// zkoumany retezec musi byt delsi

	/**
	 * delka k porovnani
	 */
	std::size_t length;

	/**
	 * typ porovnavani
	 */
	char compType;

	TestLength();
	virtual ~TestLength();

	/**
	 * otestuje, jestli je vstupni retezec stejny s predlohou
	 * testovani je case sensitive
	 */
	WRITE_TEST_HEADER

	/**
	 * moznuje nastavit parametry
	 * podporovane parametry jsou
	 * - sampe - nastavuje vzorek
	 */
	WRITE_SETPARAM_HEADER
};

} /* namespace FiniteAutomat */
#endif /* TESTLENGTH_H_ */
