/*
 * Factory.cpp
 *
 *  Created on: 1.3.2013
 *      Author: petr
 */

#include "Factory.h"

namespace FiniteAutomat {

namespace Factory {

Machine* generateStringReader(std::string quotes, std::string otherTerminals, char escape) {
	Machine* retVal = new Machine();

	State* starter = new State(retVal);
	retVal->setInitialState(starter);
	State* final = new State(retVal);
	final->setFinal(true);

	// sestaveni automatu neuvozeneho slova

	// vytvoreni stavu a nastaveni procesoru
	State* state = new State(retVal);
	ProcessorString wordProcessor;
	state->setProcessor(&wordProcessor);

	// vytvoreni prechodu a nastaveni loaderu
	Transition* trans = new Transition(starter, state, 2);
	LoaderWord wordLoader;
	wordLoader.addTerms(otherTerminals);
	wordLoader.escape = escape;
	trans->setLoader(&wordLoader);
	new Transition(state, final, 1);

	// vytvoreni casti automatu pro uvozene texty
	std::string::iterator pos = quotes.begin(), end = quotes.end();

	while (pos != end) {
		// vytvoreni stavu a nastaveni procesoru
		State* stateQ = new State(retVal);

		// vytvoreni prechodu a nastaveni loaderu uvozovky
		trans = new Transition(starter, stateQ, 1);
		LoaderChar q;
		trans->setLoader(&q);
		TestEquals *eq = new TestEquals;
		eq->sample = *pos;
		trans->getTests().push_back(eq);

		// loader retezce
		state = new State(retVal);
		state->setProcessor(&wordProcessor);
		trans = new Transition(stateQ, state, 1);
		std::string terms;
		terms += *pos;
		wordLoader.replaceTerms(terms);
		trans->setLoader(&wordLoader);

		// loader ukoncujici uvozovky
		trans = new Transition(state, final, 1);
		trans->setLoader(&q);
		trans->getTests().push_back(eq);

		pos++;
	}

	starter->orderTransitions();

	return retVal;
}

}

} /* namespace FiniteAutomat */
