/*
 * FilterCase.cpp
 *
 *  Created on: 28.2.2013
 *      Author: petr
 */

#include "FilterCase.h"

namespace FiniteAutomat {

const char* FilterCase::PARAM_TOLOWER = "tolower";

const unsigned char FilterCase::LOWER_LOW_BOUNDARY = 65;
const unsigned char FilterCase::LOWER_UP_BOUNDARY = 90;
const unsigned char FilterCase::UPPER_LOW_BOUNDARY = 97;
const unsigned char FilterCase::UPPER_UP_BOUNDARY = 122;
const unsigned char FilterCase::OFFSET = 32;

FilterCase::FilterCase() {
	toLower = false;

}

FilterCase::~FilterCase() {
	// TODO Auto-generated destructor stub
}

WRITE_DOFILTER_IMPL(FilterCase) {
	unsigned char low;
	unsigned char up;
	char multiply;		// touto hodnotou se bude nasobit offset (reseni pricitani a odcitani offsetu)
	std::string retVal;
	char curr;

	// vyhodnoceni mezi
	if (toLower) {
		low = LOWER_LOW_BOUNDARY;
		up = LOWER_UP_BOUNDARY;
		multiply = 1;
	} else {
		low = UPPER_LOW_BOUNDARY;
		up = UPPER_UP_BOUNDARY;
		multiply = -1;
	}

	// pruchod daty a jejich uprava
	std::string::const_iterator pos = data.begin(), end = data.end();

	while (pos != end) {
		// stale jsme jeste nedosli na konec dat
		curr = *pos;

		if (curr >= low && curr <= up) {
			// znak spada do intervalu prevadenych hodnot
			curr += OFFSET * multiply;
		}

		retVal.append(&curr, 1);
		pos++;
	}

	return retVal;
}

WRITE_SETPARAM_IMPL(FilterCase) {
	if (name == PARAM_TOLOWER) {
		toLower = toBool(value);
	} else {
		Filter::setParameter(name, value);
	}
}

} /* namespace FiniteAutomat */
