/*
 * LoaderWord.cpp
 *
 *  Created on: 27.2.2013
 *      Author: petr
 */

#include "LoaderWord.h"

namespace FiniteAutomat {

const char* LoaderWord::PARAM_ADD = "addterms";
const char* LoaderWord::PARAM_REPLACE = "replaceterms";
const char* LoaderWord::PARAM_ESCAPE = "escape";

LoaderWord::LoaderWord() {
	// TODO Auto-generated constructor stub
	terminals = WHITE_CHARS;
	escape = '\\';
}

FiniteAutomat::LoaderWord::LoaderWord(const LoaderWord& o) : Loader(o) {
	terminals = o.terminals;
	escape = o.escape;
}

LoaderWord::~LoaderWord() {
	// TODO Auto-generated destructor stub
}

WRITE_LOAD_IMPL(LoaderWord) {
	if (skipStartWhites)
		data = skipWhites(data);

	// nacitani dat
	std::string retVal, str = data.getData();
	std::size_t i = data.getPosition(), l = data.getLength();

	while (terminals.find(str[i]) == std::string::npos && i < l) {
		if (str[i] == escape)
			i++;

		retVal.append(&str[i], 1);

		// jeste nebyl nalezen terminal a zaroven nebylo dosazeno konce dat
		i++;
	}

	data.setPosition(i);

	return retVal;
}

void LoaderWord::addTerms(std::string terms) {
	terminals.append(terms);
}

void LoaderWord::replaceTerms(std::string terms) {
	terminals = terms;
}

WRITE_SETPARAM_IMPL(LoaderWord) {
	if (name == PARAM_ADD) {
		addTerms(value);
	} else if (name == PARAM_REPLACE) {
		replaceTerms(value);
	} else if (name == PARAM_ESCAPE) {
		escape = value.c_str()[0];
	} else {
		Loader::setParameter(name, value);
	}
}

WRITE_LOADERCLONE_IMPL(LoaderWord)

} /* namespace FiniteAutomat */
