/*
 * Machine.cpp
 *
 *  Created on: 26.2.2013
 *      Author: petr
 */

#include "Machine.h"

namespace FiniteAutomat {

Machine::Machine() {
	initialState = NULL;

}

Machine::Machine(const Machine& o) : Graph(o) {
	initialState = o.initialState;
}

Machine::~Machine() {
	// TODO Auto-generated destructor stub
}

State* Machine::getInitialInstance() {
	return initialState;
}

StateInstance* Machine::run(InputData data, void* processData) {
	if (initialState == NULL) {
		// nebyl nastaven zadny vstupni stav
		return NULL;
	}

	StateInstance* retVal = new StateInstance(initialState, data, NULL, processData, TRANSIT_RESULT());
	StateInstance* current = retVal;

	while (current != NULL) {
		// stale nebylo zpracovano vse
		try {
			current = current->transit();
		} catch (ExceptionNotFinalState& e) {
			// z aktualiniho stavu neni mozne pokracovat do zadneho dalsiho stavu
			// zkontrolujeme, zda se muzeme vratit
			if (current->getPrev() == NULL) {
				// nani mozne se vratit, pokracujeme s delegaci vyjimky
				current = NULL;
				throw e;
			} else {
				// muzeme se vratit
				current = current->getPrev();
				current->revert();
			}
		}
	}

	return retVal;
}

void Machine::setInitialState(State* state) {
	initialState = state;
}

} /* namespace FiniteAutomat */
