/*
 * StateAgregated.cpp
 *
 *  Created on: 3.3.2013
 *      Author: petr
 */

#include "StateAgregated.h"

namespace FiniteAutomat {

StateAgregated::StateAgregated(Machine* machine, Machine* agregatedMachine) : State(machine) {
	assembler = NULL;
	this->agregatedMachine = agregatedMachine;
}

StateAgregated::~StateAgregated() {
	if (assembler != NULL) delete assembler;
}

Assembler* StateAgregated::getAssembler() {
	return assembler;
}

Machine* StateAgregated::getAgregatedMachine() {
	return agregatedMachine;
}

void StateAgregated::setAssembler(Assembler* assembler) {
	if (this->assembler != NULL)
		delete this->assembler;

	this->assembler = assembler->clone();
}

void StateAgregated::setAgregatedMachine(Machine* agregatedMachine) {
	// smazani stareho automatu - ten musi existovat vzdy
	delete this->agregatedMachine;

	// nastaveni noveho
	this->agregatedMachine = agregatedMachine;
}

StateInstance* StateAgregated::createInstance(InputData data,
		StateInstance* prev, void* processData, TRANSIT_RESULT readData) {

	return new StateAgregatedInstance(this, data, processData, prev, readData);
}

void StateAgregated::setProcessor(Processor* processor) {
}

} /* namespace FiniteAutomat */
