/*
 * StateAgregatedInstance.cpp
 *
 *  Created on: 5.3.2013
 *      Author: petr
 */

#include "StateAgregatedInstance.h"

namespace FiniteAutomat {

StateAgregatedInstance::StateAgregatedInstance(StateAgregated* state,
		const InputData& data, void* processData, StateInstance* prev,
		TRANSIT_RESULT readData) :
		StateInstance(state, data, prev, processData, readData) {

	agregatedData = state->getAssembler()->prepare();

	state->getAgregatedMachine()->run(data, agregatedData);

	state->getAssembler()->assemble(processData, agregatedData);
}

void StateAgregatedInstance::revertData() {
	StateAgregated* state = (StateAgregated*) this->getState();
	state->getAssembler()->revert(processData, agregatedData);

	state->getAssembler()->revert(processData, agregatedData);
}

StateAgregatedInstance::~StateAgregatedInstance() {
	// TODO Auto-generated destructor stub
}

} /* namespace FiniteAutomat */
