/*
 * tests.cpp
 *
 *  Created on: 1.3.2013
 *      Author: petr
 */


#include <string>
#include <iostream>
#include "Machine.h"
#include "LoaderChar.h"
#include "TestEquals.h"
#include "Transition.h"
#include "Factory.h"
#include "StateInstance.h"
#include "StateAgregated.h"
#include "Transition.h"
#include "FilterCase.h"
#include "LoaderMultichar.h"
#include "AssemblerStringBubbler.h"
#include "XMLLoader.h"

using namespace FiniteAutomat;

int main() {

	Machine* agregated = Factory::generateStringReader("`", "(", '\\');
	Machine* machine = new Machine;

	State *initial = new State(machine);
	machine->setInitialState(initial);
	StateAgregated *agregatedState = new StateAgregated(machine, agregated);
	agregatedState->setFinal(true);
	Transition *trans = new Transition(initial, agregatedState, 1);

	TestEquals* eq = new TestEquals();
	eq->sample = "CREATE TABLE ";
	trans->getTests().push_back(eq);

	FilterCase *filCase = new FilterCase();
	trans->getFilters().push_back(filCase);

	LoaderMultichar loader;
	loader.n = 13;
	trans->setLoader(&loader);

	InputData testData("create table `nejaka tabulka`", 0);
	std::string parsed;
	AssemblerStringBubbler bubbler;
	agregatedState->setAssembler(&bubbler);
	// std::string *finalText = (std::string*) machine->run(testData, &parsed)->getFinalData();
	std::string *finalText = new std::string();
	std::cout << *finalText;

	delete machine;

	// test generovani z XML
	XMLLoader xLoader;
	machine = xLoader.load("tests/machine.xml");

	finalText->clear();
	finalText = (std::string*) machine->run(testData, &parsed)->getFinalData();

	std::cout << *finalText;

	return 0;
}
