/*
 * GraphNode.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef GRAPHNODE_H_
#define GRAPHNODE_H_

#include <list>
#include "Graph.h"

using namespace std;

namespace Graph {

#ifndef GRAPH_NODELIST
#define GRAPH_NODELIST

class GraphNode;
typedef list<GraphNode*> NodeList;

#endif

#ifndef GRAPH_EDGELIST
#define GRAPH_EDGELIST

class GraphEdge;
typedef list<GraphEdge*> EdgeList;

#endif

#ifndef GRAPHBASE_H_
class GraphBase;
#endif


class GraphNode : public GraphBase {

	void filter(BaseList* sourceList, NodeList* targetList, long int nodeType);

	void filter(BaseList* sourceList, EdgeList* targetList, long int rel);

	void deleteEdges(BaseList* edges);

public:

	const static int LIST_CHILDS = 0;
	const static int LIST_PARENTS = 1;

	long int nodeType;

	GraphNode(Graph* graph);
	GraphNode(Graph* graph, GraphNode* parent);
	virtual ~GraphNode();

	GraphEdge* addChild(GraphNode* child, long int rel);

	EdgeList edges(long int rel);

	EdgeList childEdges(long int rel);

	NodeList childNodes(long int nodeTypes);

	NodeList nodes(long int nodeTypes);

	EdgeList parentEdges(long int rel);

	NodeList parentNodes(long int nodeTypes);

	void removeEdge(GraphEdge* edge);

	void removeChild(GraphNode* child);

	void removeParent(GraphNode* parent);
};


}


#endif /* GRAPHNODE_H_ */
