/*
 * Column.cpp
 *
 *  Created on: 4.2.2013
 *      Author: petr
 */


#include "Column.h"

namespace SQLRepresenter {

Column::Column(Database* database, string name) : SQLBase(database) {
	this->name = name;
	notNull = true;
	dataType = "INT";
	this->nodeType = NODE_COLUMN;
	defaultUsed = false;
}

Column::~Column() {

}

IndexList Column::getIndexes() {
	Graph::NodeList nodes = parentNodes(NODE_INDEX);
	Graph::NodeList::iterator pos = nodes.begin(), end = nodes.end();
	IndexList retVal;

	while (pos != end) {
		retVal.push_back((Index*) *pos);

		pos++;
	}

	return retVal;
}

ForeignList Column::getForeigns(MATE_TYPES rels) {
	ForeignList retVal;
	Graph::EdgeList edges = parentEdges(rels);

	Graph::EdgeList::iterator pos = edges.begin(), end = edges.end();

	while (pos != end) {
		retVal.push_back((ForeignKey*) (*pos)->from());

		pos++;
	}

	return retVal;
}

Table* Column::getTable() {
	return (Table*) parentNodes(NODE_TABLE).front();
}

Column& Column::operator =(const Column& o) {
	dataType = o.dataType;
	notNull = o.notNull;
	defaultUsed = o.defaultUsed;
	defaultValue = o.defaultValue;
	extra = o.extra;

	*((SQLBase*) this) = o;

	return *this;
}

Column* Column::prev() {
	Column* retVal = NULL;
	ColumnList columns = getTable()->getColumns();
	ColumnList::iterator pos = columns.begin(), end = columns.end();

	// kontrola, jestli je zkoumany sloupec prvni v seznamu
	if (*pos == this) return retVal;

	// iterace na dalsi prvek
	pos++;

	while (pos != end && retVal == NULL) {
		if (*pos == this) {
			/// nasli jsme hledany prvek, nastavime ukazatel predchoiho
			retVal = *(--pos);
		}

		pos++;
	}

	return retVal;
}

bool Column::operator ==(const Column& o) {
	return name == o.name
			&& dataType == o.dataType
			&& notNull == o.notNull
			&& defaultUsed == o.defaultUsed
			&& defaultValue == o.defaultValue
			&& extra == o.extra
			&& *((SQLBase*) this) == (const SQLBase&) o;
}

}

