/*
 * Column.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef COLUMN_H_
#define COLUMN_H_

#include "Database.h"

#ifndef SQLBASE_H_
#include "SQLBase.h"
#endif

namespace SQLRepresenter {

class Column : public SQLBase {

public:

	string dataType;

	bool defaultUsed;

	string defaultValue;

	string extra;

	bool notNull;

	Column(Database* database, string name);
	virtual ~Column();

	/**
	 * vraci indexy, ktere se sloupcem pracuji
	 *
	 * @return IndexList
	 */
	IndexList getIndexes();

	/**
	 * vraci ukazatel na predchozi sloupec v tabulce
	 * pokud je sloupec prvni, vraci NULL
	 *
	 * @return Column*
	 */
	Column* prev();

	/**
	 * vraci cizi klice, ktere pracuji se sloupcem
	 * pomoci parametru rels lze nastavit vztah ke klici (puvodni nebo referencni sloupec)
	 *
	 * @param MATE_TYPES rels
	 * @return ForeignList
	 */
	ForeignList getForeigns(MATE_TYPES rels);

	/**
	 * vraci tabulku, ve ktere je sloupec obsazen
	 */
	Table* getTable();

	Column& operator=(const Column& o);

	bool operator==(const Column& o);
};

}


#endif /* COLUMN_H_ */
