/*
 * Comparator.h
 *
 *  Created on: 24.3.2013
 *      Author: petr
 */

#ifndef COMPARATOR_H_
#define COMPARATOR_H_

#include "Database.h"
#include <string>

#define COMPARE_HEADER Database* oldDatabase, Database* newDatabase, Database* substract
#define COMPARE_TABLE_HEADER Table* oldTable, Table* newTable, Table** subTable, Database* substract
#define PREPARE_COMPARATION(NODE_TYPE) NodeList oldFns = oldDatabase->getNodes(NODE_TYPE), newFns = newDatabase->getNodes(NODE_TYPE);\
NodeList missing, newbies, stays;\
getDifference(oldFns, newFns, missing, newbies, stays);

#define PREPARE_TABLE_COMPARATOR(NODE_TYPE) NodeList oldItems = oldTable->childNodes(NODE_TYPE), newItems = newTable->childNodes(NODE_TYPE);\
NodeList missing, stays, newbies;\
getDifference(oldItems, newItems, missing, newbies, stays);\
if (newbies.size() > 0 || missing.size() > 0) createTableIfNeeds(subTable, newTable, substract);\
if ((*subTable) != NULL) checkTableChangeStatus(*subTable);

namespace SQLRepresenter {

class Comparator {

	void getDifference(NodeList oldNodes, NodeList newNodes, NodeList& missing, NodeList& newbies, NodeList& stays);

	void compareTables(COMPARE_HEADER);

	void compareTriggers(COMPARE_HEADER);

	void compareFunctions(COMPARE_HEADER);

	void compareProcedures(COMPARE_HEADER);

	void compareViews(COMPARE_HEADER);

	void compareColumns(COMPARE_TABLE_HEADER);

	void compareIndexes(COMPARE_TABLE_HEADER);

	void compareChecks(COMPARE_TABLE_HEADER);

	void compareForeigns(COMPARE_TABLE_HEADER);

	Trigger* createTriggerByOrig(Database* substract, Trigger* original, SQLBase::COMPARE_RESULT cr);

	Column* getOrCreateColumn(Table* table, std::string name);

	Index* getOrCreateIndex(Table* table, std::string name, ColumnList columns);

	Check* getOrCreateCheck(Table* table, std::string name, std::string code);

	ColumnList copyColumns(Table* table, ColumnList otherColumns);

	bool isInList(GraphNode* node, NodeList &otherNodes);

	void checkTableChangeStatus(Table* table);

	void createTableIfNeeds(Table** table, Table* origin, Database* substract);

public:
	Comparator();
	virtual ~Comparator();

	Database* compare(Database* oldDatabase, Database* newDatabase);
};

} /* namespace SQLRepresenter */
#endif /* COMPARATOR_H_ */
