/*
 * ForeignKey.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef FOREIGNKEY_H_
#define FOREIGNKEY_H_

#include "Database.h"

namespace SQLRepresenter {

#ifndef TABLE_H_
class Table;
#endif



class ForeignKey : public SQLBase {

	void createEdges(ColumnList columns, MATE_TYPES mate);

	ColumnList edgesToColumns(Graph::EdgeList edges);

	void removeEdges(MATE_TYPES edgeTypes, NODE_TYPES nodeTypes);

public:

	string onDelete;

	string onUpdate;

	ForeignKey(Database* database, string name);
	virtual ~ForeignKey();

	ColumnList getColumns();

	ColumnList getReferencedColumns();

	Table* getReferencedTable();

	Table* getTable();

	void setColumns(ColumnList columns);

	void setReferencedColumns(ColumnList columns);

	void setReferencedTable(Table* table);

	ForeignKey &operator =(const ForeignKey& o);

	bool operator ==(const ForeignKey& o);

	ForeignKey &operator=(ForeignKey &o);
};

}


#endif /* FOREIGNKEY_H_ */
