/*
 * Column.cpp
 *
 *  Created on: 4.2.2013
 *      Author: petr
 */

#include "Index.h"

namespace SQLRepresenter {

Index::Index(Database* database, string name):SQLBase(database) {
	this->name = name;
	indexType = INDEX_TYPE_KEY;
	indexMethod = "BTREE";
	nodeType = NODE_INDEX;
}

Index::~Index() {

}

ColumnList Index::getColumns() {
	ColumnList retVal;
	Graph::NodeList nodes = childNodes(NODE_COLUMN);

	Graph::NodeList::iterator pos = nodes.begin(), end = nodes.end();

	while(pos != end) {
		retVal.push_back((Column*) *pos);

		pos++;
	}

	return retVal;
}

Table* Index::getTable() {
	return (Table*) parentNodes(NODE_TABLE).front();
}

Index& Index::operator =(const Index& o) {
	indexType = o.indexType;
	indexMethod = o.indexMethod;

	*((SQLBase *) this) = (const SQLBase&) o;

	return *this;
}

bool Index::operator ==(const Index& o) {

	return indexMethod == o.indexMethod && indexType == o.indexType && *((SQLBase*) this) == (const SQLBase&) o;
}

}
