/*
 * LocalAdapter.h
 *
 *  Created on: 18.4.2013
 *      Author: petr
 */

#ifndef LOCALADAPTER_H_
#define LOCALADAPTER_H_

#include "Adapter.h"
#include <vector>
#include "Trigger.h"
#include "Database.h"
#include "ConflictFinder.h"

namespace SQLRepresenter {

class LocalAdapter: public SQLRepresenter::Adapter {

	void diffRoutines(Database *database);

	void diffTables(Database *database);

	void diffViews(Database *database);

	void copyColumns(Table *table, Table *dTable);

	void copyKeys(Table *table, Table *dTable);

	void diffTable(Table *dTable);

	void diffForeigns(Table *dTable);

	void createTable(Table *dTable);

	bool isConflict(SQLBase* element);

public:

	Database* target;

	Conflicts conflicts;

	LocalAdapter();
	virtual ~LocalAdapter();

	virtual Database* readData(Database* database);

	virtual void setConfig(pugi::xml_node config);

	virtual void writeData(Database* database);

	virtual void writeDiff(Database* database);
};

};

#endif /* LOCALADAPTER_H_ */
