/*
 * Procedure.cpp
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#include "Procedure.h"

namespace SQLRepresenter {

Procedure::Procedure(Database* database, string name) : SQLBase(database) {
	nodeType = NODE_PROCEDURE;
	dataAccess = Procedure::DA_CONTAINSQL;
	this->name = name;
}

Procedure::~Procedure() {
	// TODO Auto-generated destructor stub
}

PROC_PARAM& Procedure::addParameter(string name, string dataType,
		string defVal) {

	PROC_PARAM param = {name, dataType, defVal, IN, SQLBase::CR_NOCOMPARE};

	params.push_back(param);

	return params.back();
}

void Procedure::clearParameters() {
	params.clear();
}

void Procedure::dropParameter(string name) {
	ProcParamList::iterator pos = params.begin(), end = params.end();

	while (pos != end) {
		if (pos->name == name) {
			pos = params.erase(pos);
		} else {
			pos++;
		}
	}
}

PROC_PARAM& Procedure::getParameter(string name) {
	ProcParamList::iterator pos = params.begin(), end = params.end();

	while (pos != end) {
		if (pos->name == name) return *pos;

		pos++;
	}

	return *params.end();
}

ProcParamList Procedure::getParameters() {
	return params;
}

bool Procedure::hasParameter(string name) {
	ProcParamList::iterator pos = params.begin(), end = params.end();

	while (pos != end) {
		if (pos->name == name) return true;

		pos++;
	}

	return false;
}

void Procedure::setParameters(ProcParamList params) {
	clearParameters();

	this->params = params;
}

bool Procedure::operator ==(const Procedure& o) {
	// porovnani parametru
	if (params.size() != o.params.size()) return false;

	ProcParamList::const_iterator pos = params.begin(), oPos = o.params.begin(), end = params.end();

	while (pos != end) {
		PROC_PARAM p1 = *pos, p2 = *oPos;
		if (!(p1.dataType == p2.dataType && p1.defVal == p2.defVal && p1.name == p2.name && p1.paramType == p2.paramType)) return false;

		pos++;
		oPos++;
	}

	return dataAccess == o.dataAccess && code == o.code && *((SQLBase*) this) == (const SQLBase&) o;
}

Procedure& SQLRepresenter::Procedure::operator =(const Procedure& o) {
	dataAccess = o.dataAccess;
	code = o.code;
	params = o.params;

	*((SQLBase*) this) = o;

	return *this;
}

} /* namespace SQLRepresenter */

