/*
 * Procedure.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef PROCEDURE_H_
#define PROCEDURE_H_

#include <string>
#include "Database.h"

using namespace std;

namespace SQLRepresenter {


#ifndef PROCEDURE_CLASS
#define PROCEDURE_CLASS
#endif

class Procedure: public SQLRepresenter::SQLBase {

	ProcParamList params;

public:

	enum DATA_ACCESS_MODS {
		DA_NOSQL = 0,
		DA_CONTAINSQL = 1,
		DA_READSQLDATA = 2,
		DA_MODIFYSQLDATA = 3
	};

	DATA_ACCESS_MODS dataAccess;

	string code;

	Procedure(Database* database, string name);
	virtual ~Procedure();

	PROC_PARAM& addParameter(string name, string dataType, string defVal = "");

	void clearParameters();

	void dropParameter(string name);

	PROC_PARAM& getParameter(string name);

	ProcParamList getParameters();

	bool hasParameter(string name);

	void setParameters(ProcParamList params);

	bool operator==(const Procedure& o);

	Procedure &operator=(const Procedure& o);

};

} /* namespace SQLRepresenter */

#include "Function.h"

#endif /* PROCEDURE_H_ */
