/*
 * SQLBase.cpp
 *
 *  Created on: 27.1.2013
 *      Author: petr
 */

#include "SQLBase.h"

namespace SQLRepresenter {

SQLBase::SQLBase(Database* database) : GraphNode(database) {
	compareResult = CR_NOCOMPARE;
	id = database->nextId++;
	dbName = database->name;
}

SQLBase::~SQLBase() {

}

PARAMETER& SQLBase::createParameter(string name) {
	PARAMETER& retVal = params[name];
	retVal.switcher = false;

	return retVal;
}

bool SQLBase::deleteParameter(string name) {
	if (isParameter(name)) {
		params.erase(name);
		return true;
	}

	return false;
}

PARAMETER& SQLBase::getParameter(string name) {
	ParamMap::iterator pos;

	pos = params.find(name);

	return pos->second;
}

SQLBase* SQLBase::getParent() {
	return (SQLBase*) this->parentNodes(MATE_MAJOR_PARENT).front();
}

SQLBase* SQLBase::findItem(NodeList items, string name) {
	NodeList::iterator pos = items.begin(), end = items.end();

	while (pos != end) {
		if (((SQLBase*) *pos)->name == name) return (SQLBase*) *pos;

		pos++;
	}

	return NULL;
}

const ParamMap& SQLBase::getParameters() {
	return params;
}

bool SQLBase::isParameter(string name) {
	return (params.find(name) == params.end()) ? false : true;
}

void SQLBase::dropItem(NodeList items, string name) {
	NodeList::iterator pos = items.begin(), end = items.end();
	SQLBase *currentItem = findItem(items, name);

	if (currentItem != NULL) {
		delete currentItem;
	}
}

bool SQLBase::operator ==(const SQLBase& o) {
	return name == o.name && comment == o.comment;
}

SQLBase& SQLBase::operator =(const SQLBase& o) {
	name = o.name;
	comment = o.comment;
	compareResult = o.compareResult;
	params = o.params;

	return *this;
}

}
