/*
 * Trigger.h
 *
 *  Created on: 6.2.2013
 *      Author: petr
 */

#ifndef TRIGGER_H_
#define TRIGGER_H_

#include <string>
#include "Database.h"

using namespace std;

namespace SQLRepresenter {

enum TRIGGER_TIME {
	BEFORE = 1,
	AFTER = 2
};

enum TRIGGER_OPERATION {
	INSERT = 1,
	UPDATE = 2,
	DELETE = 4
};

class Trigger: public SQLRepresenter::SQLBase {
public:

	string code;

	TRIGGER_OPERATION operation;

	TRIGGER_TIME time;

	Trigger(Database* database);
	virtual ~Trigger();

	Table* getTable();

	bool operator==(const Trigger& o);

	Trigger &operator=(const Trigger& o);
};

} /* namespace SQLRepresenter */
#endif /* TRIGGER_H_ */
