/*
 * Configurator.h
 *
 *  Created on: 15.4.2013
 *      Author: petr
 */

#ifndef CONFIGURATOR_H_
#define CONFIGURATOR_H_

#include <string>
#include <iostream>
#include <cerrno>

#include "pugixml.hpp"
#include "Representation/Adapter.h"
#include "Representation/MySQLAdapter.h"

#ifndef CONFIG_PATH
#define CONFIG_PATH "../config/"
#endif

using namespace pugi;
using namespace std;

class Configuration {

	xml_document document;

	xml_node user;

	xml_node path;

	xml_node active;

	xml_node dbconfig;

	xml_node findDbParam(string name);

	string generateFileName(string name);

public:

	static const char* NODE_ROOT;
	static const char* NODE_USERINFO;
	static const char* NODE_DB;
	static const char* NODE_PATH;
	static const char* NODE_ACTIVE;
	static const char* ATTR_USERNAME;
	static const char* ATTR_EMAIL;
	static const char* ATTR_ADAPTER;

	static const char* ADAPTER_MYSQL;

	Configuration();

	Configuration(const Configuration& o);

	virtual ~Configuration();

	SQLRepresenter::Adapter* createAdapter();

	void exportConfig(string name);

	string getActive();

	string getDbAdapter();

	xml_node getDbConfig();

	string getDbParam(string name);

	string getEmail();

	string getPath();

	string getUserName();

	void importConfig(string name);

	void setActive(string uuid);

	void setAdapter(const char *adapter);

	void setDbParam(string name, string value);

	void setEmail(string email);

	void setPath(string path);

	void setUserName(string name);
};

void createConfiguration(string name);

void createMySQLConfiguration(Configuration &config);

void showConfiguration(string name);

void showMySQLConfiguration(Configuration &config);


#endif /* CONFIGURATOR_H_ */
