//============================================================================
// Name        : Tribble.cpp
// Author      : Petr Jindra
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <string>
#include <fstream>

#include "Configurator.h"
#include "export.h"
#include "diff.h"
#include "merge.h"

using namespace std;

void printHelp() {
	cout << "Database version system Tribble" << endl << endl;
	cout << "create conf <config_name>                  creates new configuration file" << endl;
	cout << "create diff <config_name>                  creates new diff package of database" << endl;
	cout << "show conf <config_name>                    shows configuration settings" << endl;
	cout << "export db <config_name> <filename>         exports database to XML file" << endl;
	cout << "merge <config_name>                        merge two branches" << endl;
	cout << "help                                       print this help" << endl;

	cout << endl;
}

int main(int argc, char** argv) {

	// zpracovani parametru prikazove radky
	if (argc > 1) {
		string command(argv[1]);

		if (command == "create") {
			if (argc < 3) {
				printHelp();
				return 0;
			}

			command = argv[2];

			if (command == "conf") {
				// bude se vytvaret konfigurace
				string name(argv[3]);

				createConfiguration(name);
			} else if (command == "diff") {
				string name(argv[3]);

				createDiff(name);
			}
		} else if (command == "show") {

			command = argv[2];

			if (command == "conf") {
				string name(argv[3]);

				showConfiguration(name);
			}
		} else if (command == "export") {
			command = argv[2];

			if (command == "db") {
				exportDatabase(argv[3], argv[4]);
			}
		} else if (command == "merge") {
			doMerge(argv[2]);
		} else {
			// jakykoliv jiny vstup vypise help
			printHelp();
		}
	} else {
		// vypsani helpu
		printHelp();
	}

	return 0;
}
